﻿<%@ WebHandler Language="C#" Class="ApiTradeOrderRequest" %>

using System.Configuration;
using System.Web;
using System.Text;
using com.upay.upayException;
using com.upay.Icc;
using com.upay.Web;
using Newtonsoft.Json.Linq;
using com.upay;
using System;
using com.upay.Entity;
public class ApiTradeOrderRequest : BaseRequest
{
    public override void OnProcessRequest(HttpContext context)
    {

        string url = ConfigurationManager.AppSettings["IccOrderapiUrl"];
        string privatepfxpath = HttpContext.Current.Server.MapPath("../../package/client.pfx");
        String pfxPassword = "123456";
        string publiccrepath = HttpContext.Current.Server.MapPath("../../package/server.cer");
        string aesKeyValue = com.upay.Aes.GenerateRandomNumber(16);
        ApiTradeOrder order = new ApiTradeOrder();

        order.MerchantId = context.Request.Form["merchantId"];
        order.RequestId = context.Request.Form["requestId"];
        order.OrderAmount = context.Request.Form["orderAmount"];
        order.OrderCurrency = context.Request.Form["orderCurrency"];
        order.NotifyUrl = context.Request.Form["notifyUrl"];
        
        ShipInfo ShipInfo = new ShipInfo();
        ShipInfo.ShipStreet = context.Request.Form["shipStreet"];
        ShipInfo.ShipCity = context.Request.Form["shipCity"];
        ShipInfo.ShipState = context.Request.Form["shipState"];
        ShipInfo.ShipPost = context.Request.Form["shipPost"];
        ShipInfo.ShipCountry = context.Request.Form["shipCountry"];
        ShipInfo.ShipPhone = context.Request.Form["shipPhone"];
        ShipInfo.ShipEmail = context.Request.Form["shipEmail"];
        order.ShipInfo = ShipInfo;

        BillInfo BillInfo = new BillInfo();
        BillInfo.BillStreet = context.Request.Form["billStreet"];
        BillInfo.BillCity = context.Request.Form["billCity"];
        BillInfo.BillState = context.Request.Form["billState"];
        BillInfo.BillPost = context.Request.Form["billPost"];
        BillInfo.BillCountry = context.Request.Form["billCountry"];
        BillInfo.BillPhone = context.Request.Form["billPhone"];
        BillInfo.BillEmail = context.Request.Form["billEmail"];

        order.TerminalNo = context.Request.Form["terminalNo"];
        order.Remark = context.Request.Form["remark"];
        order.FirstName = context.Request.Form["firstName"];
        order.LastName = context.Request.Form["lastName"];
        order.CardNo = context.Request.Form["cardNo"];
        order.ExpireM = context.Request.Form["expireM"];
        order.ExpireY = context.Request.Form["expireY"];
        order.CardCvv2 = context.Request.Form["cardCvv2"];
        order.Ordip = context.Request.Form["ordip"];

        var a = JObject.Parse(order.Json); //将 a 中的 json 解码
        string hm = string.Join("", GetValue.Getvalue1(a));
        string SHA1hmac = SHA1.EncryptToSHA1(hm.ToString());
        string hmac = Rsa.privateSign(privatepfxpath, SHA1hmac, pfxPassword);
        order.Hmac = hmac;
        StringBuilder sbHmac = new StringBuilder();
        sbHmac.Append(hm);
        sbHmac.Append(hmac);
        sbHmac.Append("#");

        string encryptKey = Rsa.CFCAencryption(publiccrepath, aesKeyValue);
        string merchantId = context.Request.Form["merchantId"];
        string requestId = context.Request.Form["requestId"];


        string data = Aes.Encrypt(order.Json.ToString(), aesKeyValue);


        HttpClient client = new HttpClient(url, merchantId, encryptKey, requestId);
        string responsestr = client.Post(data.ToString(), privatepfxpath, pfxPassword);

        JObject jo = JObject.Parse(responsestr);
        jo.Remove("hmac");//去除返回json中的hmac

        var b = JObject.Parse(jo.ToString()); //将 a 中的 json 解码
        string json = string.Join("", GetValue.Getvalue1(b));
        string SHA1H = SHA1.EncryptToSHA1(json.ToString());//根据返回参数摘要出SHA1


        ApiTradeOrderBack back = new ApiTradeOrderBack(responsestr);

        Boolean bo = Rsa.VerifySign(SHA1H, publiccrepath, back.Hmac);

        if (bo == false) throw new HmacVerifyException(responsestr);//确认签名结果
        
        if (back.Status == "SUCCESS")
        {
            context.Response.Clear();
            context.Response.Write("处理成功！<br/>");
            context.Response.Write(responsestr);
        }
        else if (back.Status == "FAILED")
        {
            context.Response.Clear();
            context.Response.Write("处理失败！<br/>");
            context.Response.Write(responsestr);
        }
      
        else
        {
            throw new ResponseException(responsestr);
        }
    }
}